#ifndef HELLOWORLDLIBRARY_H
#define HELLOWORLDLIBRARY_H

#include "helloworld-library_global.h"

// Forward declarations are needed in case the
// header references classes that have not yet
// been included. In this example the private
// class is forward-declarared, since its header
// is not exported from the project
class HWLibPrivate;

// HELLOWORLDLIBRARYSHARED_EXPORT in needed in Windows environment
// to do proper exports. See the previous Qt course slides for details
// It maps into __declspec(dllexport) / __declspec(dllimport)
class HELLOWORLDLIBRARYSHARED_EXPORT HelloWorldLibrary
{
public:
    // Constructor and destructor are usually public
    HelloWorldLibrary();
    ~HelloWorldLibrary();

    // A member function to print something
    void printHello();

private:
    // An example of using an object that's not visible in public API.
    // Private implementation pattern is the preferred way of declaring
    // public API's as it prevents binary incompatibilities due to
    // class size changes
    // Check for example "opaque pointer" from Wikipedia for details
    HWLibPrivate *privateObj;
};

#endif // HELLOWORLDLIBRARY_H
